package apple

import (
	"github.com/gin-gonic/gin"
	appleLogic "github.com/perfect-panel/server/internal/logic/public/iap/apple"
	"github.com/perfect-panel/server/internal/svc"
	"github.com/perfect-panel/server/internal/types"
	"github.com/perfect-panel/server/pkg/result"
)

func AttachAppleTransactionHandler(svcCtx *svc.ServiceContext) func(c *gin.Context) {
	return func(c *gin.Context) {
		var req types.AttachAppleTransactionRequest
		_ = c.ShouldBind(&req)
		if err := svcCtx.Validate(&req); err != nil {
			result.ParamErrorResult(c, err)
			return
		}
		l := appleLogic.NewAttachTransactionLogic(c.Request.Context(), svcCtx)
		resp, err := l.Attach(&req)
		result.HttpResult(c, resp, err)
	}
}
